<template>
  <transition name="fade">
    <div @click.self="$emit('close')" class="modal-wrapper">
      <button class="close-btn pointer" @click="$emit('close')">
        <i class="ic-close"></i>
      </button>
      <slot></slot>
    </div>
  </transition>
</template>
<script>
export default {
  methods: {},
  mounted() {
    document.documentElement.classList.toggle("no-scroll", true);
  },
  destroyed() {
    document.documentElement.classList.toggle("no-scroll", false);
  }
};
</script>
<style lang="scss">
.modal-wrapper {
  z-index: 1000;
  position: fixed;
  background-color: rgba(0, 0, 0, 0.75);
  left: 0;
  top: 0;
  bottom: 0;
  right: 0;
  overflow: scroll;
  -webkit-overflow-scrolling: touch;
}

.ic-close {
  display: block;
  width: 1px;
  height: 1px;
  left: 50%;
  top: 50%;
  position: absolute;
  transform: translate(-50%, -50%);

  &:before,
  &:after {
    position: absolute;
    left: -7px;
    content: "";
    width: 14px;
    height: 2px;
    display: block;
    background-color: #fff;
    border-radius: 1px;
  }

  &:before {
    transform: rotate(45deg);
  }
  &:after {
    transform: rotate(-45deg);
  }
}
.close-btn {
  position: fixed;
  top: 10px;
  right: 10px;
  width: 32px;
  height: 32px;
  background-color: $color-primary-black;
  z-index: 2;
  appearance: none;
  border: none;
  padding: 0;
  display: block;
  transform-origin: right top;

  @include media-breakpoint-up(md) {
    transform: scale(1.5);
    right: 50px;
    top: 50px;
  }
}

.fade-enter-active {
  transition: opacity 0.5s;
}
.fade-enter,
.fade-leave-to {
  opacity: 0;
  transition: opacity 0.5s;
}
</style>
